#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define MAXPLAYER 30

int Schedule[MAXPLAYER][MAXPLAYER+1];

void tournament( int startplayer, int endplayer )
{
    int i, j, k, n;
    if (endplayer == startplayer + 1)
    {
        // we have only two players so play them together in one day
        Schedule[1][startplayer] = endplayer;
        Schedule[1][endplayer] = startplayer;
    }
    else // Schedule both halves of this section of the tournament
    {
        n = endplayer - startplayer + 1; // number of players to be scheduled
        tournament( startplayer, endplayer - n / 2 ); // first half
        tournament( startplayer + n / 2, endplayer ); // second half
        // now every player in each half has played together
        // schedule the players of different halves
        for (i = n / 2; i <= n - 1; i++) // schedule day i up to n - 1
        {
            for ( j = startplayer; j <= startplayer + n / 2 - 1; j++ )
                // schedule player j on day i
            {
                k = j + i;
                if (k >= startplayer + n) // wrap back around
                {
                    k = k - n / 2;
                }
                Schedule[i][j] = k;
                Schedule[i][k] = j;
            }
        }
    }
}

int main()
{
    char days[]="Day";
    int i, j, n = 0;
    dohttp://blogs.technet.com/b/askpfeplat/archive/2013/03/12/slow-boot-slow-login-sbsl-hotfix-rollup-for-windows-7-and-server-2008-r2-available-today.aspx
    {
      printf("Number of players [>1, even]: ");
      scanf("%d", &n);
    }
    while (n < 2 || n % 2 != 0);
    tournament(1, n);
    printf("       Tournament Players\n     ");
    for (i=1; i <= n; i++)
        printf("%3d ", i);
    printf("\n");
    for (i=1; i < n; i++)
    {
        printf("%c%3d ", (i <= strlen(days))? days[i-1]: ' ', i);
        for (j=1; j <= n; j++)
            printf("%3d ", Schedule[i][j]);
        printf("\n");
    }
    return 0;
}
